
import List

-- sets as lists

-- intersection

s1 /\ s2 = nub [ a | a <- s1 , elem a s2]

-- sets as coreflexives

r1 ./\. r2 = r1 .* r2

-- where relational composition .* is defined by

r .* s = nub [ (c,a) | (c,b) <- r , (b',a) <- s , b == b']

-- preconditioning

pre r s = r .* (set2cor s)

-- conversion 

set2cor s = [(a,a) | a <- s ]

cor2set = map fst

-- test data

r1 = [("a",1),("b",1),("b",2)]
r2 = [(1,True),(1, False)]

s1 = [3,5,6,1,9]
s2 = [6,9,10]

test = do {
		print ("s1 =" ++ show s1) ;
		print ("coreflexive rep of s1 =" ++ show (set2cor s1)) ;
		print ("s2 =" ++ show s2) ;
		print ("coreflexive rep of s2 =" ++ show (set2cor s2)) ;
	}

